//   Main.java --- Plagiat

//   Copyright (C) 2004 Moise Valvassori <djedi@ai.univ-paris8.fr>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.plagiat;

import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStreamReader;

/**
 * Interface texte qui detecte un plagiat
 * @author "Moise Valvassori" <djedi@ai.univ-paris8.fr>
 * @version "$Id: Main.java,v 1.2 2004/01/10 12:44:43 djedi Exp $"
 * @since Thu Jan  8 15:20:01 2004
 */
public class Main {
  /**
   * Creates a new <code>Main</code> instance.
   *
   */
  public static void main (String args[]) {
    if (args.length != 1) {
      System.out.println("Usage: $JAVA $MAINCLASS <input-file>");
      return ;
    }

    try {
      File f = new File(args[0]);
      FileInputStream inp = new FileInputStream(f);
      new Plagiat("").analyse();
      inp.close();
    } catch (IOException e) {
      e.printStackTrace();
    }
    System.exit(0);
  }
}
