//   PlagiatEvent.java --- Plagiat Detector

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.plagiat;

/**
 *
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: PlagiatEvent.java,v 1.3 2004/05/15 09:27:41 djedi Exp $
 * @since Sat Jan 10 12:29:54 2004
 */
public class PlagiatEvent {
  private String str;
  private int start;
  private int end;
  private String cmt;
  private int type;

  /**
   * Un segment est trouve sur google
   */
  public static final int FOUND = 0;
  /**
   * Une partie du ducument est parse
   */
  public static final int PARSE = 1;
  /**
   * le coef d'un segment a change
   */
  public static final int COEF  = 2;

  /**
   * Creates a new <code>PlagiatEvent</code> instance.
   *
   */
  public PlagiatEvent (int type, String str, int start, int end, String cmt) {
    this.type = type;
    this.str = str;
    this.start = start;
    this.end = end;
    this.cmt = cmt;
  }

  public String getString() {
    return str;
  }

  public int getStart() {
    return start;
  }

  public int getEnd() {
    return end;
  }

  public int getType() {
    return type;
  }

  public String getCmt() {
    return cmt;
  }
}
