//   MainFrame.java --- Plagiat

//   Copyright (C) 2004 Moise Valvassori <djedi@ai.univ-paris8.fr>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.plagiat.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.IOException;
import java.net.URL;
import java.util.Comparator;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.TreeMap;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.WindowConstants;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyleContext;
import javax.swing.text.StyledDocument;

import org.djedi.plagiat.Plagiat;
import org.djedi.plagiat.PlagiatEvent;
import org.djedi.plagiat.PlagiatListenner;

/**
 * Fenetre principale.
 * @author "Moise Valvassori" <djedi@ai.univ-paris8.fr>
 * @version "$Id: MainFrame.java,v 1.7 2004/05/15 09:27:41 djedi Exp $"
 * @since Fri Jan  9 16:06:56 2004
 */
public class MainFrame extends JFrame implements ActionListener, PlagiatListenner {
  private JTextPane tp;
  private JProgressBar progress;
  private Style style2;
  private Style hight_style;
  private JTextField url;
  private Plagiat p;
  

  /**
   * Creates a new <code>MainFrame</code> instance.
   *
   */
  public MainFrame (String urlname) {
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    tp = new JTextPane();
    tp.setContentType("text/text");
    tp.setEditable(false);
    tp.addMouseListener(new MouseAdapter() {
	public void mousePressed(MouseEvent e) {
	  //	  System.out.println(e);
	  
	  if (!e.isPopupTrigger())
	    return;

	  int loc = tp.viewToModel(e.getPoint());
	  //	  System.out.println(tp.getStyledDocument().getCharacterElement(loc).getAttributes().getAttributeCount());
	  System.out.println(tp.getStyledDocument().getCharacterElement(loc).getAttributes().getAttribute("URL"));
	  //	  System.out.println(tp.getStyledDocument().getCharacterElement(loc).getAttributes().getAttribute("color"));
//  	  for (Enumeration en= 
// 		 tp.getStyledDocument().getCharacterElement(loc).getAttributes().getAttributeNames(); 
// 	       en.hasMoreElements();){
// 	    Object o = en.nextElement();
//  	    System.out.println(o+" "+o.getClass());
// 	  }
	}
      });


    // Style style = StyleContext.getDefaultStyleContext().getStyle(StyleContext.DEFAULT_STYLE);
    //      doc.addStyle("regular", null);
    style2 = tp.getStyledDocument().addStyle("fluo", null);
    //    StyleConstants.setBold(style2, true);
    StyleConstants.setBackground(style2, Color.YELLOW);
    //    StyleConstants.setComponent(style2, new JButton("Bouton"));

    hight_style = tp.getStyledDocument().addStyle("corellation", null);
    StyleConstants.setBackground(hight_style, Color.GREEN);
//     JButton but = new JButton("Bouton");
//     but.setToolTipText("toto");
//     StyleConstants.setComponent(style2, but);


    JScrollPane s = new JScrollPane(tp);
    getContentPane().add(s);
    s.setPreferredSize(new Dimension(500,500));

    JPanel panel = new JPanel();
    panel.add(new JLabel("URL:"));
    url = new JTextField(urlname,20);
    panel.add(url);

    JButton load = new JButton("load");
    load.addActionListener(this);
    panel.add(load);
    JButton bout = new JButton("start");
    bout.addActionListener(this);
    panel.add(bout);
    JButton ana = new JButton("analyse");
    ana.addActionListener(this);
    panel.add(ana);
    //    ana.setEnabled(false);
    getContentPane().add(panel,BorderLayout.NORTH);


    progress = new JProgressBar(0,tp.getStyledDocument().getLength());
    getContentPane().add(progress,BorderLayout.SOUTH);
    pack();
  }

  public void actionPerformed(ActionEvent ev) {
    final MainFrame mf = this;

    if ("start".equals(ev.getActionCommand().toString()))
      new Thread () {
	public void run () {
	  StyledDocument doc = tp.getStyledDocument();
	  progress.setMaximum(tp.getStyledDocument().getLength());

	  try{
	    String str = doc.getText(0,doc.getLength());
	    System.out.println(str);
	    p = new Plagiat(str);
	    p.addPlagiatListenner(mf);
	    p.doquerie();
	    //	  doc.setCharacterAttributes(startWord, i.getIndex()-startWord, style2, false);
	  } catch (Exception e) {
	  }
	}}.start();

    if ("load".equals(ev.getActionCommand().toString()))
      try {
	URL u = new URL(url.getText());
	tp.setPage(u);
      } catch (IOException e) {
	e.printStackTrace();
      }

    if ("analyse".equals(ev.getActionCommand().toString()))
      p.analyse();
  }


  public void plagiatDetected(PlagiatEvent e) {
    switch (e.getType()) {
    case PlagiatEvent.PARSE:
      progress.setValue(e.getEnd());
      break;
    case PlagiatEvent.FOUND:
      tp.getStyledDocument().setCharacterAttributes(e.getStart(), e.getEnd() - e.getStart(), style2, false);
      break;
    case PlagiatEvent.COEF:
      TreeMap se = (TreeMap)
	tp.getStyledDocument().getCharacterElement(e.getStart()).getAttributes().getAttribute("URL");
      if (se==null)
	se = new TreeMap(new Comparator(){
	    public int compare(Object o1, Object o2) {
	      int r = ((Float)o1).compareTo(o2);
	      if (r<0)
		return 1;
	      else if (r>0)
		return -1;
	      return 0;
	    }	
	    public boolean equals(Object obj) {
	      return this.equals(obj);
	    }
	  });
      //      System.out.println(se);

      StringTokenizer st = new StringTokenizer(e.getCmt(),""); 
      se.put(new Float(st.nextToken()),st.nextToken());
      SimpleAttributeSet s = new SimpleAttributeSet();
      s.addAttribute("URL",se);
      tp.getStyledDocument().setCharacterAttributes(e.getStart(), e.getEnd() - e.getStart(), s, false);


      float f=0;
      for (Iterator i = se.keySet().iterator(); i.hasNext();){
	f += ((Float)i.next()).floatValue();
      }
      //      System.out.println(f);
      
      f = 1 - f/50;
      if (f>0)
	StyleConstants.setBackground(hight_style, new Color(f,1,0));
      else
	StyleConstants.setBackground(hight_style, new Color(0,(float)1,0));
      tp.getStyledDocument().setCharacterAttributes(e.getStart(), e.getEnd() - e.getStart(), hight_style, false);
      break;
    default:
      break;
    }
  }

}
