//   Query.java --- Snafu

//   Copyright (C) 2002 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.snafu;

import java.util.LinkedList;
import java.util.ArrayList;


/**
 *
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: Query.java,v 1.3 2004/01/08 16:45:29 djedi Exp $
 * @since Sat Nov 23 18:00:17 2002
 */
public class Query {
  private static int currentid = 0;
  private Integer id;
  private String words;
  private ArrayList results;


  /**
   * Creates a new <code>Query</code> instance.
   *
   */
  public Query (String word) {
    words = word;
    id = new Integer(currentid ++);
    results = new ArrayList();
  }

  public Integer getId() {
    return id;
  }

  public String getQuery() {
    return words;
  }

  public synchronized void add (SearchResultEntry e) {
    results.add(e);
  }

  public int hashCode() {
    return words.hashCode();
  }
  public boolean equals(Object o) {
    if (o instanceof Query) {
      return ((Query)o).getQuery().equals(id);
    }
    return false;
  }

  public ArrayList getResultList() {
    return results;
  }

  public int size() {
    return results.size();
  }
}
