//   ResultEvent.java --- Snafu

//   Copyright (C) 2002 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.snafu;

import java.util.EventObject;


/**
 *
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: ResultEvent.java,v 1.2 2002/11/24 20:42:24 djedi Exp $
 * @since Sat Nov 23 21:16:49 2002
 */
public class ResultEvent extends EventObject {
  private Integer qid;
  private SearchResultEntry entry;
  /**
   * Creates a new <code>ResultEvent</code> instance.
   *
   */
  public ResultEvent (Coordinator source,Integer qid, SearchResultEntry e) {
    super(source);
    this.qid = qid;
    this.entry = e;
  }

  public Integer getId() {
    return qid;
  }

  public SearchResultEntry getEntry() {
    return entry;
  }

  public String toString () {
    return "[Result from "+getSource()+" "+qid+"]";
  }
}
