//   SearchResultEntry.java --- Snafu

//   Copyright (C) 2002 Moise Valvassori <djedi@ai.univ-paris8.fr>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.snafu;
import java.net.URL;
import java.net.MalformedURLException;
/**
 *
 * @author "Moise Valvassori" <djedi@ai.univ-paris8.fr>
 * @version 1.0
 * @since Thu Nov 21 15:47:52 2002
 */
public class SearchResultEntry implements Comparable {
  private URL url;
  private String title;
  private String desc;
  /**
   * Creates a new <code>SearchResultEntry</code> instance.
   *
   */
  public SearchResultEntry (String url, String title, String desc) {
    try {
      this.url = new URL(url);
    } catch (MalformedURLException e) {
      e.printStackTrace();
    }
    this.title = title;
    this.desc = desc;
  }

  public URL getURL () {
    return url;
  }
  public String getTitle () {
    return title;
  }
  public String getDesc () {
    return desc;
  }

  public int hashCode() {
    return url.hashCode();
  }
  // public boolean equals() {
  //   return 
  // }

  public String toString () {
    return url+" - "+title;
  }

  public int compareTo (Object to) {
    if (to instanceof SearchResultEntry)
      return title.compareTo(((SearchResultEntry)to).getTitle());
    return title.compareTo(to);
    
  }
}
