//   OptionDialog.java --- Snafu

//   Copyright (C) 2002 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.snafu.gui;

import javax.swing.JDialog;
import java.awt.Container;
import javax.swing.JLabel;
import java.awt.Frame;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import javax.swing.JButton;
import java.awt.FlowLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JSlider;


/**
 *
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: OptionDialog.java,v 1.3 2002/12/03 10:48:39 djedi Exp $
 * @since Mon Nov 25 21:50:34 2002
 */
public class OptionDialog extends JDialog {
  private Snafu parent;
  private JSlider slider;

  /**
   * Creates a new <code>OptionDialog</code> instance.
   *
   */
  public OptionDialog (Snafu parent) {
    super((Frame)parent,true);
    this.parent = parent;

    Container cp = getContentPane();
    //    cp.setLayout(new BorderLayout());

    JPanel p = new JPanel();
    p.add(new JLabel("Number of pages per engine"));
    slider = new JSlider(0,100,25);
    slider.setMajorTickSpacing(20);
    slider.setMinorTickSpacing(5);
    slider.setPaintTicks(true);
    slider.setPaintLabels(true);
    slider.setPaintTrack(true);
    p.add(slider);

    cp.add(p,BorderLayout.CENTER);

    JPanel bas = new JPanel(new FlowLayout(FlowLayout.RIGHT));
    JButton ok = new JButton("Ok");
    ok.addActionListener(new ActionListener () {
	public void actionPerformed(ActionEvent e) {
	  setParameter();
	  hide();
	}
      });
    bas.add(ok);
    cp.add(bas,BorderLayout.SOUTH);
    pack();
  }

  private void setParameter() {
    parent.setNumberPages(slider.getValue());
  }
}
