//   Snafu.java --- Snafu

//   Copyright (C) 2002 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.snafu.gui;
import org.djedi.snafu.Coordinator;
import javax.swing.JFrame;
import javax.swing.JLabel;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.Container;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JTabbedPane;
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;


/**
 *
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: Snafu.java,v 1.5 2004/01/07 17:02:21 djedi Exp $
 * @since Sat Nov 23 21:31:03 2002
 */
public class Snafu extends JFrame {
  private Coordinator coordinator;
  private JTextField queryText;
  private JTabbedPane queriesPane;
  private OptionDialog optionDialog = null;
  private Snafu _this = this;

  /**
   * Creates a new <code>Snafu</code> instance.
   *
   */
  public Snafu () {
    super("Snafu.");
    coordinator = new Coordinator();

    Container cp = getContentPane();

    JPanel queryaskp = new JPanel();
    queryaskp.add(new JLabel("Expression:"));
    queryText = new JTextField(23);
    queryaskp.add(queryText);

    JButton button = new JButton("Search");
    button.addActionListener(new ActionListener () {
	public void actionPerformed(ActionEvent e) {
	  new Thread() {
	    public void run() {
	      newQuery(queryText.getText());
	    }}.start();
	}
      });
    queryaskp.add(button);

    cp.add(queryaskp,BorderLayout.NORTH);

    queriesPane = new JTabbedPane ();
    queriesPane.setPreferredSize(new Dimension(500,400));
    cp.add(queriesPane);

    // quitte l'appli si on ferme la fentre
    addWindowListener(new WindowAdapter() {
	public void windowClosing(WindowEvent e) {
	  System.exit(0);
	}
      });


    // Le menu
    JMenuBar menuBar = new JMenuBar();
    setJMenuBar(menuBar);

    JMenu menu = new JMenu("File");
    menuBar.add(menu);
    JMenuItem menuItem = new JMenuItem("Option");
    menuItem.addActionListener(new ActionListener () {
	public void actionPerformed(ActionEvent e) {
	  if (optionDialog == null) {
	    optionDialog = new OptionDialog(_this);
	  }
	  optionDialog.show();
	}
      });
    menu.add(menuItem);
    menu.addSeparator();
    menuItem = new JMenuItem("Quit");
    menuItem.addActionListener(new ActionListener () {
	public void actionPerformed(ActionEvent e) {
	  System.exit(0);
	}
      });
    menu.add(menuItem);

    pack();
    setVisible(true);
  }

  protected void newQuery(String query) {
    if ("".equals(query))
      return ;
    
    QueryPane q = new QueryPane(coordinator, coordinator.search(query));
    coordinator.addResultListenner(q);
    queriesPane.addTab(query,q);
    queriesPane.setSelectedComponent(q);
    
  }

  void setNumberPages(int n) {
    coordinator.setNumberPages(n);
  }

  public static void main (String[] args) {
    new Snafu();
  }
}
